#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1300eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 1300"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight13004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight13004xi = {
                1:'-1009x-333y-747z',
                2:'-1010x-529y-623z',
                3:'-1032x-282y-737z',
                4:'-1042x-478y-611z',
                5:'-1053x-229y-726z',
                6:'-1071x-175y-715z',
                7:'-1071x-425y-600z',
                8:'-1085x-119y-704z',
                9:'-1098x-370y-588z',
                10:'-1121x-314y-576z',
                11:'-1142x-256y-565z',
                12:'-118x-255y-1269z',
                13:'-122x-442y-1216z',
                14:'-12x-191y-1285z',
                15:'-133x-874y-952z',
                16:'-137x-259y-1266z',
                17:'-146x-1000y-817z',
                18:'-148x-447y-1211z',
                19:'-157x-263y-1263z',
                20:'-163x-1280y-155z',
                21:'-176x-449y-1206z',
                22:'-177x-264y-1260z',
                23:'-181x-875y-944z',
                24:'-198x-265y-1256z',
                25:'-200x-999y-807z',
                26:'-204x-451y-1201z',
                27:'-220x-264y-1253z',
                28:'-229x-873y-935z',
                29:'-230x-1271y-142z',
                30:'-233x-450y-1196z',
                31:'-242x-261y-1250z',
                32:'-24x-203y-1283z',
                33:'-254x-995y-796z',
                34:'-262x-447y-1191z',
                35:'-265x-257y-1246z',
                36:'-277x-869y-926z',
                37:'-287x-251y-1242z',
                38:'-28x-1286y-181z',
                39:'-292x-443y-1186z',
                40:'-296x-1259y-129z',
                41:'-2x-178y-1287z',
                42:'-308x-987y-786z',
                43:'-309x-243y-1238z',
                44:'-322x-436y-1181z',
                45:'-325x-862y-916z',
                46:'-332x-233y-1234z',
                47:'-352x-428y-1175z',
                48:'-354x-222y-1230z',
                49:'-362x-1242y-116z',
                50:'-362x-977y-776z',
                51:'-374x-852y-907z',
                52:'-376x-209y-1226z',
                53:'-37x-214y-1281z',
                54:'-382x-418y-1170z',
                55:'-397x-195y-1222z',
                56:'-40x-864y-970z',
                57:'-40x-993y-837z',
                58:'-411x-405y-1164z',
                59:'-416x-964y-765z',
                60:'-418x-178y-1217z',
                61:'-422x-839y-898z',
                62:'-427x-1223y-103z',
                63:'-439x-160y-1212z',
                64:'-441x-391y-1158z',
                65:'-458x-141y-1208z',
                66:'-469x-948y-755z',
                67:'-470x-375y-1152z',
                68:'-470x-824y-888z',
                69:'-476x-120y-1203z',
                70:'-491x-1200y-90z',
                71:'-494x-97y-1198z',
                72:'-498x-356y-1146z',
                73:'-50x-452y-1324z',
                74:'-510x-72y-1193z',
                75:'-517x-805y-879z',
                76:'-51x-224y-1279z',
                77:'-522x-928y-744z',
                78:'-525x-47y-1188z',
                79:'-526x-336y-1140z',
                80:'-552x-313y-1133z',
                81:'-553x-1173y-77z',
                82:'-563x-784y-869z',
                83:'-574x-906y-733z',
                84:'-578x-289y-1127z',
                85:'-603x-263y-1121z',
                86:'-609x-760y-859z',
                87:'-614x-1143y-64z',
                88:'-625x-881y-723z',
                89:'-626x-235y-1114z',
                90:'-648x-205y-1107z',
                91:'-654x-734y-850z',
                92:'-669x-174y-1100z',
                93:'-66x-233y-1277z',
                94:'-674x-1110y-51z',
                95:'-674x-852y-712z',
                96:'-697x-705y-840z',
                97:'-71x-428y-1225z',
                98:'-723x-821y-701z',
                99:'-731x-1073y-38z',
                100:'-739x-673y-830z',
                101:'-770x-787y-690z',
                102:'-780x-638y-820z',
                103:'-786x-1034y-25z',
                104:'-815x-750y-679z',
                105:'-819x-601y-810z',
                106:'-82x-241y-1274z',
                107:'-840x-992y-12z',
                108:'-856x-562y-799z',
                109:'-858x-711y-668z',
                110:'-86x-870y-961z',
                111:'-890x-946y0z',
                112:'-891x-521y-789z',
                113:'-899x-669y-657z',
                114:'-924x-477y-779z',
                115:'-939x-625y-645z',
                116:'-93x-998y-827z',
                117:'-955x-431y-768z',
                118:'-95x-1285y-168z',
                119:'-96x-436y-1220z',
                120:'-976x-578y-634z',
                121:'-983x-383y-758z',
                122:'-99x-249y-1271z'}

#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1300eight4xi" usage = "target function for charge1300eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1300eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1300EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1300EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1300EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1300EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1300EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight13004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1300EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1300EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1300EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight13004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight13004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1300EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1300EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1300EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1300eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                      